<?php

namespace Drupal\menu_select;

use Drupal\Core\Menu\MenuParentFormSelector;

/**
 * Override the core 'menu.parent_form_selector' service.
 */
class MenuSelectParentFormSelector extends MenuParentFormSelector {

  /**
   * {@inheritdoc}
   */
  public function parentSelectElement($menu_parent, $id = '', array $menus = NULL) {
    // Instead of building out a select list, return the custom menu select tree
    // element.
    return [
      '#type' => 'menu_select_tree',
      '#default_value' => $menu_parent,
      '#menu_parent' => $menu_parent,
      '#options' => !isset($menus) ? $this->getMenuOptions($menus) : $menus,
      '#max_depth' => $this->getParentDepthLimit($id),
      '#current_link_id' => $id,
    ];
  }

}